/************************************************************************
*   ACCESS SAMPLE PROGRAM                                               *
*                                                              BY CAD'S *
*                                                                       *
*       The program of deleting unused Detail (Batch mode)              *
*                                                                       *
************************************************************************/
#include    <string.h>
#include    <stdio.h>
#include    <stdlib.h>
#include    <memory.h>
#include    <ctype.h>
#define     VOL_4                       /* Drive is 4 characters */
#include    "accfnc.h"
#include    "accarg.h"

extern  short logfopen(char*);
extern  short logmsg(long);
extern  void  logfclse(void);
extern  short logusrid(long);
extern  short dtlpack(long,char*,char*,char*);

#define FALSE                   0
#define TRUE                    1

#define SPACE_CHAR            ' '

#define VOL_LEN                 4
#define GROUP_LEN               4
#define USER_LEN                6
#define CHKLEN                100
#define USERID_LEN              8
#define PASSWD_LEN              8

#define INVALID_PARA            1

static  short chkpara(char*,char*,char*);
static  short brkpara_from(char*,char*,char*,char*);
static  short brkpara_id(char*,char*,char*);

struct PARM {
        long    from_flag;
        char    from[CHKLEN+1];
        long    opt_flag;
        long    opt;
        long    message_flag;
        char    message[CHKLEN+1];
        long    id_flag;
        char    id[CHKLEN+1];
        char    userid[CHKLEN+1];
        char    passwd[CHKLEN+1];
};
static struct PARM PARM;

void    ac2userp(void)
{
    short   retc;
    long    iflgar[3];
    long    ioutar[3];
    long    modear[3];
    long    eflag;
    char    vol[VOL_LEN+1];         /* Drive */
    char    group[GROUP_LEN+1];     /* Group */
    char    user[USER_LEN+1];       /* User */

    /*--------------*/
    /* Initial      */
    /*--------------*/
    eflag = TRUE;
    memset(vol,   '\0', sizeof(vol));
    memset(group, '\0', sizeof(group));
    memset(user,  '\0', sizeof(user));
    PARM.from_flag = 0;
    PARM.opt_flag = 0;
    PARM.message_flag = 0;
    PARM.id_flag = 0;

    /*--------------*/
    /* MC_bubegn    */
    /*--------------*/
    iflgar[0] = 52L;
    iflgar[1] = 0L;
    iflgar[2] = 2L;
    retc = MC_bubegn(10L, iflgar, ioutar, 10L);
    if (retc != 0) return;

    /*--------------*/
    /* MC_bumode    */
    /*--------------*/
    modear[0] = 2L;
    modear[1] = 0L;
    modear[2] = 12L;
    retc = MC_bumode(1L, modear, 10L);
    if (retc != 0) eflag = FALSE;

    if (eflag == TRUE) {
        /*--------------------------*/
        /* Check input parameters   */
        /*--------------------------*/
        retc = chkpara(vol, group, user);
        if (retc != 0) {
            logmsg(retc);
            eflag = FALSE;
        }
    }
    if (eflag == TRUE) {
        /*--------------------------*/
        /* Login                    */
        /*--------------------------*/
        if ( PARM.id_flag == 1 ) {
            retc = MC_usrid ( PARM.userid, PARM.passwd, "        ", "        " );
            if (retc != 0) {
                logusrid(retc);
                eflag = FALSE;
            }
        }
    }
    if (eflag == TRUE) {
        /*------------------------------------------*/
        /* The process of deleting unused detail    */
        /*------------------------------------------*/
        retc = dtlpack(PARM.opt, vol, group, user);
    }
    /*--------------------------------------*/
    /* Close the log file if necessary      */
    /*--------------------------------------*/
    logfclse();

    MC_buend(1L, 10L);
    return;
}
/************************************************************************
*                                                                       *
*   Check paramter and get vol, group and user information              *
*   If necessary, open the log file                                     *
*                                                                       *
*       fvol    : Volume                                                *
*       fgrp    : Group                                                 *
*       fusr    : User                                                  *
*                                                                       *
************************************************************************/
static  short chkpara(char *fvol, char *fgrp, char *fusr)
{
    short   retc;
    long    ii, jj;
    long    len;
    char    keywd[CHKLEN+1];
    char    *kwd;

    /*--------------------------*/
    /* Check input parameters   */
    /*--------------------------*/
    if (ACCARG.argc < 2) {
        return(INVALID_PARA);
    }

    /*--------------------------*/
    /* Check MSG parameters     */
    /*--------------------------*/
    retc = 0;
    for (ii = 1; ii < ACCARG.argc; ii++) {
        len = (long)strlen(ACCARG.argv[ii]);
        if (len == 0)
            break;
        if (len > CHKLEN)
            len = CHKLEN;
        strncpy(keywd, ACCARG.argv[ii], len);
        keywd[len] = '\0';

        kwd = strchr(keywd, '=');
        if (kwd == NULL) {
            retc = INVALID_PARA;
            break;
        }

        *kwd = '\0';
        kwd++;
        len = (long)strlen(keywd);
        for (jj = 0; jj < len; jj++) {
            keywd[jj] = (char)toupper((unsigned char)keywd[jj]);
            ACCARG.argv[ii][jj] = keywd[jj];
        }
        if (strcmp(keywd, "MSG") == 0 ||
            strcmp(keywd, "M") == 0) {
            len = (long)strlen(keywd);
            if (len > 49 || len < 1) {
                retc = INVALID_PARA;
                break;
            }
            if (PARM.message_flag == 1)
                break;
            /*--------------------------*/
            /* Open the log file        */
            /*--------------------------*/
            retc = logfopen(kwd);
            if (retc != 0) {
                return(1);
            }
            strcpy(PARM.message, kwd);
            len = (long)strlen(PARM.message);
            PARM.message_flag = 1;
        }
    }
    /*--------------------------*/
    /* Check each parameter     */
    /*--------------------------*/
    for (ii = 1; ii < ACCARG.argc; ii++) {
        len = (long)strlen(ACCARG.argv[ii]);
        if (len == 0)
            break;
        if (len > CHKLEN)
            len = CHKLEN;
        strncpy(keywd, ACCARG.argv[ii], len);
        keywd[len] = '\0';
        for (jj = 0; jj < len; jj++) {
            keywd[jj] = (char)toupper((unsigned char)keywd[jj]);
            ACCARG.argv[ii][jj] = keywd[jj];
        }
        /*--------------------------*/
        /* Check FROM parameter     */
        /*--------------------------*/
        if (strncmp(ACCARG.argv[ii], "FROM=", 5) == 0) {
            if (strlen(ACCARG.argv[ii]+5) > 16) {
                retc = INVALID_PARA;
                break;
            }

            strcpy(PARM.from, ACCARG.argv[ii]+5);
            PARM.from_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "F=", 2) == 0) {
            if (strlen(ACCARG.argv[ii]+2) > 16) {
                retc = INVALID_PARA;
                break;
            }
            strcpy(PARM.from, ACCARG.argv[ii]+2);
            PARM.from_flag = 1;
        }
        /*--------------------------*/
        /* Check OPT parameter      */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "OPT=", 4) == 0) {
            if (strlen( ACCARG.argv[ii]+4 ) > 1) {
                retc = INVALID_PARA;
                break;
            }
            PARM.opt = atoi(ACCARG.argv[ii]+4);
            if (PARM.opt < 1 || PARM.opt > 3) {
                retc = INVALID_PARA;
                break;
            }
            PARM.opt_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "O=", 2) == 0) {
            if (strlen(ACCARG.argv[ii]+2) > 1) {
                retc = INVALID_PARA;
                break;
            }
            PARM.opt = atoi(ACCARG.argv[ii]+2);
            if (PARM.opt < 1 || PARM.opt > 3) {
                retc = INVALID_PARA;
                break;
            }
            PARM.opt_flag = 1;
        }
        /*--------------------------*/
        /* Check ID parameter       */
        /*--------------------------*/
        else if (strncmp(ACCARG.argv[ii], "ID=", 3) == 0) {
            if (strlen( ACCARG.argv[ii]+3 ) > 17) {
                retc = INVALID_PARA;
                break;
            }
            strcpy(PARM.id, ACCARG.argv[ii]+3);
            PARM.id_flag = 1;
        }
        else if (strncmp(ACCARG.argv[ii], "I=", 2) == 0) {
            if (strlen( ACCARG.argv[ii]+2 ) > 17) {
                retc = INVALID_PARA;
                break;
            }
            strcpy(PARM.id, ACCARG.argv[ii]+2);
            PARM.id_flag = 1;
        }
    }
    if (retc == 0) {
        if (PARM.from_flag == 0 ||
            PARM.opt_flag == 0  ||
            PARM.id_flag == 0)
            retc = INVALID_PARA;
    }
    if (retc != 0)
        return(retc);
    /*----------------------------------------------*/
    /* Get vol, group and user from input string    */
    /*----------------------------------------------*/
    retc = brkpara_from(PARM.from, fvol, fgrp, fusr);
    if (retc != 0)
        return(retc);
    /*----------------------------------------------*/
    /* Get userid and password from input string    */
    /*----------------------------------------------*/
    if (PARM.id_flag == 1) {
        retc = brkpara_id(PARM.id, PARM.userid, PARM.passwd);
    }
    return(retc);
}
/************************************************************************
*                                                                       *
*   Get vol, group and user from input string                           *
*                                                                       *
*       buff    : Input string                                          *
*       fvol    : Volume                                                *
*       fgrp    : Group                                                 *
*       fusr    : User                                                  *
*                                                                       *
************************************************************************/
static  short brkpara_from(char *buff, char *fvol, char *fgrp, char *fusr)
{
    long    len;
    char    *grp;
    char    *usr;

    /*------------------------------*/
    /* Separate USER from string    */
    /*------------------------------*/
    fusr[0] = '\0';
    usr = strchr(buff, ',');
    if (usr != NULL) {
        *usr = '\0';
        usr++;
        len = (long)strlen(usr);
        if (len > USER_LEN || len < 1) {
            return(INVALID_PARA);
        }
        memcpy(fusr, usr, len);
        memset(&fusr[len], SPACE_CHAR, USER_LEN-len);
        fusr[USER_LEN] = '\0';
    }
    /*------------------------------*/
    /* Separate GROUP from string   */
    /*------------------------------*/
    grp = strchr(buff, ':');
    if (grp == NULL) {
        return(INVALID_PARA);
    }
    fgrp[0] = '\0';
    *grp = '\0';
    grp++;
    len = (long)strlen(grp);
    if (len > GROUP_LEN || len < 1) {
        return(INVALID_PARA);
    }
    memcpy(fgrp, grp, len);
    memset(&fgrp[len], SPACE_CHAR, GROUP_LEN-len);
    fgrp[GROUP_LEN] = '\0';
    /*------------------------------*/
    /* Separate VOL from string     */
    /*------------------------------*/
    len = (long)strlen(buff);
    if (len > VOL_LEN || len < 1) {
        return(INVALID_PARA);
    }
    memcpy(fvol, buff, len);
    memset(&fvol[len], SPACE_CHAR, VOL_LEN-len);
    fvol[VOL_LEN] = '\0';
    return(0);
}
/************************************************************************
*                                                                       *
*   Get userid and password from input string                           *
*                                                                       *
*       buff    : Input string                                          *
*       userid  : User ID                                               *
*       passwd  : Password                                              *
*                                                                       *
************************************************************************/
static  short brkpara_id(char *buff, char *userid, char *passwd)
{
    long    len;
    char    *pwd;

    /*------------------------------*/
    /* Separate PASSWD from string  */
    /*------------------------------*/
    passwd[0] = '\0';
    pwd = strchr(buff, ',');
    if (pwd != NULL) {
        *pwd = '\0';
        pwd++;
        len = (long)strlen(pwd);
        if (len > PASSWD_LEN || len < 1) {
            return(INVALID_PARA);
        }
        memcpy(passwd, pwd, len);
        memset(&passwd[len], SPACE_CHAR, PASSWD_LEN-len);
        passwd[PASSWD_LEN] = '\0';
    }
    /*------------------------------*/
    /* Separate USERID from string  */
    /*------------------------------*/
    len = (long)strlen(buff);
    if (len > USERID_LEN || len < 1) {
        return(INVALID_PARA);
    }
    memcpy(userid, buff, len);
    memset(&userid[len], SPACE_CHAR, USERID_LEN-len);
    userid[USERID_LEN] = '\0';
    return(0);
}
